{ Fortran: EQUIVALENCE ( ... ) }
Unit AMMCR_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure AMMCR(var A :Array of Real; N :Integer; NCA :Integer;
                var B :Array of Real; NLB :Integer; NUB :Integer;
                var C :Array of Real); 
implementation

procedure AMMCR(var A :Array of Real; N :Integer; NCA :Integer;
                var B :Array of Real; NLB :Integer; NUB :Integer;
                var C :Array of Real);
var
NLC,M,NUC,L,IRB,LDZROA,NCP1,NCP2,NCB,NCC,NLCP1,NUBP1,IRC,JCC,IVB,
   LDZROC,NCP2X,NVB,IRA,JCA,LDZROB,JCB,NLZBA,INCA,ICC :Integer;
SUM :Real;
const
ZERO :Real = 0.0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15;
begin
NCP1 := NCA+1;
NCP2 := NCA+2;
NCB := NLB+1+NUB;
M := Min0(NCA+NLB,N-1);
NLC := M; {   EQUIVALENCE  FORTRANe }
L := Min0(NCA+NUB,N-1);
NUC := L; {   EQUIVALENCE  FORTRANe }
NCC := M+L+1;
NLCP1 := NLC+1;
NUBP1 := NUB+1;
for IRC:=1 to N do
 begin
  JCC := 1;
  IVB := 1;
  LDZROC := NLCP1-IRC;
  if ( LDZROC ) < 0
   then goto _3
   else if ( LDZROC ) > 0
         then goto _1
         else goto _4;
_1:
  for JCC:=1 to LDZROC do
   begin
    C[(IRC-1)+(JCC-1)*N] := ZERO;
_2:
   end;
  JCC := LDZROC+1;
  goto _4;
_3:
  IVB := 1-LDZROC;
_4:
  LDZROA := Max0(IRC-NCP1,0);
  NCP2X := NCP2-IRC;
  for NVB:=IVB to N do
   begin
    SUM := 0.0;
    IRA := IRC;
    JCA := Max0(NCP2X,1);
    LDZROB := Max0(NVB-NUBP1,0);
    IRB := LDZROB+1;
    JCB := Min0(NVB+NLB,NCB);
    NLZBA := LDZROB-LDZROA;
    if ( NLZBA ) < 0
     then goto _8
     else if ( NLZBA ) > 0
           then goto _5
           else goto _9;
_5:
    for INCA:=1 to NLZBA do
     begin
      if ( (IRA <> IRC) ) or ( (JCA >= NCP1) ) 
       then goto _6;
      JCA := JCA+1;
      goto _7;
_6:
      JCA := JCA-1;
      IRA := IRA+1;
_7:
     end;
    goto _9;
_8:
    JCB := JCB+NLZBA;
    IRB := IRB-NLZBA;
_9:
    if ( (JCA < 1) ) or ( (IRA > N) ) or ( (JCB < 1)
         ) or (         (IRB > N) ) 
     then goto _12;
    SUM := SUM+A[(IRA-1)+(JCA-1)*N]*B[(IRB-1)+(JCB-1)*N];
    if ( (IRA <> IRC) ) or ( (JCA >= NCP1) ) 
     then goto _10;
    JCA := JCA+1;
    goto _11;
_10:
    JCA := JCA-1;
    IRA := IRA+1;
_11:
    JCB := JCB-1;
    IRB := IRB+1;
    goto _9;
_12:
    if ( JCC > NCC ) 
     then goto _15;
    C[(IRC-1)+(JCC-1)*N] := SUM;
    JCC := JCC+1;
_13:
   end;
  if ( JCC > NCC ) 
   then goto _15;
  for ICC:=JCC to NCC do
   begin
    C[(IRC-1)+(ICC-1)*N] := ZERO;
_14:
   end;
_15:
 end;
end;

end.
